<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%!
String getSampleForLocation(List<Sample> samples, int offset, int position)
{
	String name = "<i>empty</i>";
	int index = offset + position - 1;
	if (index < samples.size())
	{
		Sample s = samples.get(index);
		name = "<b>" + HTML.encodeTags(s.getName()) + "</b>";
		try
		{
			BioWell well = s.getBioWell();
			if (well != null)
			{
				BioPlate plate = well.getPlate();
				name += " [" + plate.getName() + " " + well.getCoordinate() + "]";
			}
		}
		catch (PermissionDeniedException ex)
		{}
	}
	return name;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
final int BLOCKS_PER_PAGE = 3;
final int SAMPLES_PER_BLOCK = 5;
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final int listId = Values.getInt(request.getParameter("workList"));
	BioMaterialList workList = BioMaterialList.getById(dc, listId);
	
	ItemQuery<Sample> query = (ItemQuery<Sample>)workList.getMemberBioMaterials();
	
	query.join(Hql.leftJoin(null, "bioWell", "bw", null, true));
	query.join(Hql.leftJoin("bw", "bioPlate", "bp", null, true));
	
	// Sort by bioplate position
	query.order(Orders.asc(Hql.expression("coalesce(bp.name, 'zzzz')", null)));
	query.order(Orders.asc(Hql.property("bw", "row")));
	query.order(Orders.asc(Hql.property("bw", "column")));
	query.order(Orders.asc(Hql.property("id")));

	List<Sample> histology = query.list(dc);
	
	int totalBlocks = 1 + (histology.size()-1) / SAMPLES_PER_BLOCK;
	int totalPages = 1 + (totalBlocks-1) / BLOCKS_PER_PAGE;
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>Lab tracking protocol for FFPE/HE</title>
	<link rel="SHORTCUT ICON" href="<%=home%>/images/microscope.png">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<script language="JavaScript" src="<%=root %>/include/scripts/main.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root %>/include/scripts/ajax.js" type="text/javascript" charset="UTF-8"></script>

	<style>
	table.protocolheader
	{
		width: 100%;
	}
	
	table.protocolheader > tbody > tr
	{
		height: 2em;
	}

	table.protocolheader > tbody > tr > th, table.protocolheader > tbody > tr > td b
	{
		text-align: left;
		font-size: 1.25em;
	}
	
	div.paraffinblock
	{
		margin-top: 1em;
		margin-bottom: 2em;
		height: 6.5cm;
	}
	
	div.paraffinblock .title
	{
		font-size: 1.2em;
		margin-bottom: 0.5em;
	}
	
	div.paraffinblock > table
	{
		width: 100%;
		height: 5.5cm;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	div.paraffinblock > table > tbody > tr > td
	{
		vertical-align: top;
		border: 1px solid #000000;
		padding: 2px;
		width: 50%;
	}
	
	div.entryform
	{
		margin-left: 0.5em;
		margin-right: 1em;
		border: 1px solid #000000;
		height: 2em;
	}
	</style>
	
	<script>
	function downloadHEGlassLabels()
	{
		var numLabelsPerBlock = prompt('Number of labels per block?', 5);
		if (numLabelsPerBlock == null) return;
		
		if (!parseInt(numLabelsPerBlock)) 
		{
			alert('"' + numLabelsPerBlock + '" is not a valid number');
			return;
		}
		
		var url = 'Histology.servlet?ID=<%=ID%>&cmd=DownloadHEGlassLabels';
		url += '&workListId=<%=listId%>';
		url += '&numSlides=' + parseInt(numLabelsPerBlock);
		
		location.href = url;
	}
	
	</script>
</head>
<body>
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<span class="button" onclick="window.print()">
			<img src="images/print.png">Print&hellip;
		</span>
		
		<span class="button" onclick="downloadHEGlassLabels()" style="margin-left: 2em;">
			<img src="images/download.png">Download HE glass labels&hellip;
		</span>
	</div>
	<%
	int pageNo = 0;
	for (int blockNo = 0; blockNo < totalBlocks; ++blockNo)
	{
		AnyToAny link = AnyToAny.getByName(dc, workList, "block."+(blockNo+1));
		BioPlate block = (BioPlate)link.getTo();
		int offset = SAMPLES_PER_BLOCK * blockNo;
		if (blockNo % BLOCKS_PER_PAGE == 0)
		{
			pageNo++;
			%>
			<div class="<%=blockNo > 0 ? "pagebreak" : ""%>"></div>
			<h1>Lab tracking protocol for FFPE/HE v.1.0</h1>
			<table class="protocolheader">
			<tr>
				<td colspan="2">Reggie <%=reggie.getAbout().getVersion() %>; Page <%=pageNo %> of <%=totalPages %></td>
			</tr>
			<tr>
				<td colspan="2"><b>Work list:</b> <%=HTML.encodeTags(workList.getName()) %> (<%=workList.getSize() %> samples)</td>
			</tr>
			<tr>
				<th style="width: 50%;">Start date:</th>
				<th style="width: 50%;">Operator:</th>
			</tr>
			</table>
			<%
		}
		%>
		<div class="paraffinblock">
			<div class="title">
				<table style="width: 100%;">
				<tr>
					<td style="width: 50%;">
						<table style="width: 100%;">
						<tr>
							<td style="width: 25%; white-space: nowrap;"><b>Block:</b> <%=block.getName() %></td>
							<td style="width: 75%;"><div class="entryform">&nbsp;</div></td>
						</tr>
						</table>
					</td>
					
					<td style="width: 50%;">
						<table style="width: 100%;">
						<tr>
							<td style="width: 25%; white-space: nowrap;"><b>Slides: </b><%=block.getName().replace("PB", "HE") %>.#</td>
							<td style="width: 75%;"><div class="entryform" style="margin-right: 0em;">&nbsp;</div></td>
						</tr>
						</table>
					</td>
				</tr>
				</table>
			</div>
			<table>
				<tr>
				<td>
					<b>3</b>: <%=getSampleForLocation(histology, offset, 3) %>
				</td>
				<td>
					<b>6</b>: <i>not used</i>
				</td>
				</tr>
				
				<tr>
				<td>
					<b>2</b>: <%=getSampleForLocation(histology, offset, 2) %>
				</td>
				<td>
					<b>5</b>: <%=getSampleForLocation(histology, offset, 5) %>
				</td>
				</tr>
				
				<tr>
				<td>
					<b>1</b>: <%=getSampleForLocation(histology, offset, 1) %>
				</td>
				<td>
					<b>4</b>: <%=getSampleForLocation(histology, offset, 4) %>
				</td>
				</tr>
			</table>
		</div>
		<%
	}
	%>
	
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>