<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	boolean isAdmin = user.getId() == SystemItems.getId(User.ROOT);
	boolean isPatientCurator = false;
	boolean hasCreateSamplePermission = sc.hasPermission(Permission.CREATE, Item.SAMPLE);
	boolean hasCreateExtractPermission = sc.hasPermission(Permission.CREATE, Item.EXTRACT);
	boolean hasCreateBioPlatePermission = sc.hasPermission(Permission.CREATE, Item.BIOPLATE);
	if (!isAdmin)
	{
		try
		{
			Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
			isAdmin = sc.isMemberOf(admin);
		}
		catch (RuntimeException ex)
		{}
	}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
%>
<base:page type="default" >
<base:head styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
<style>
dl
{
	margin-top: 0px;
	padding: 3px;
}
dt
{
	margin-top: 0.5em;
	margin-left: 0.5em;
}
dd
{
	margin-left: 0.5em;
	margin-bottom: 0.5em;
}
ul
{
	margin-top: 0px;
	margin-bottom: 0px;
}
img
{
	vertical-align: text-bottom;
}
h3
{
	color: #333377;
	background: #E8E8E8;
	font-weight: bold;
	margin-bottom: 0em;
	padding: 1px 4px 1px 4px;
	border: 1px solid #A0A0A0;
	font-size: 1em;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement title="Reggie" /></p:path>

	<div class="content">
		<div class="absolutefull" style="width: 50%;">
			<div class="absolutefull" style="left: 1em; right: 0.5em; ">
				
				<%
				if (isAdmin)
				{
					%>
					<h3>Server administrator wizards</h3>
					<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home + "/images/install.png" %>" />
						<a href="install.jsp?ID=<%=ID%>">Installation wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Check that annotation types and other items used by Reggie exists in BASE.
						<li>Create missing items.
						</ul>
					</dd>
					</dl>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<h3>Personal information wizards</h3>
					<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home + "/images/personal.png" %>"/>
						<a href="persinfo.jsp?ID=<%=ID%>">Pathology referral form registration</a>
					</dt>
					<dd>
						<ul>
						<li>Register new cases and patients.
						<li>Update existing cases and specimen tubes.
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home + "/images/blood.png" %>"/>
						<a href="bloodform.jsp?ID=<%=ID%>">Blood referral form registration</a>
					</dt>
					<dd>
						<ul>
						<li>Register new blood referral forms and patients.
						<li>Update information for existing blood referral forms.
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home+"/images/consent.png" %>"/>
						<a href="consentform.jsp?ID=<%=ID%>">Consent form registration</a>
					</dt>
					<dd>
						<ul>
						<li>Register consent forms.
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home+"/images/export_import.png" %>" />
						Export/import information to/from external registers.
					</dt>
					<dd>
						<ul>
						<li><a href="export_monthly_oplist.jsp?ID=<%=ID%>">Export monthly operation list</a>
						</ul>
					</dd>
					</dl>
					<%
				}
				%>
				
				<h3>Laboratory wizards</h3>
				<dl class="leftborder rightborder bottomborder">
				<%
				if (hasCreateSamplePermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/specimen.png" %>" />
						<a href="specimentube.jsp?ID=<%=ID%>">Specimen tube registration</a>
					</dt>
					<dd>
						<ul>
						<li>Register new specimen tubes.
						<li>Update existing specimen tubes.
						</ul>
					</dd>
					<%
				}
				if (hasCreateSamplePermission && hasCreateExtractPermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/partition.png" %>" />
						<a href="partitionform.jsp?ID=<%=ID%>">Partition wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register new partitions of existing specimens.
						</ul>
					</dd>
					<%
				}
				if (hasCreateSamplePermission && hasCreateBioPlatePermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/microscope.png" %>" />
						Histology wizards
					</dt>
					<dd>
						<ul>
						<li><a href="histology_protocol.jsp?ID=<%=ID%>">Lab tracking protocol for FFPE/HE</a>
						<li><a href="histology_block.jsp?ID=<%=ID%>">Register paraffin blocks</a>
						<li><a href="histology_glass.jsp?ID=<%=ID%>">Register histology HE glass information</a>
						</ul>
					</dd>
					<%
				}
				if (hasCreateExtractPermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/extraction.png" %>" />
						DNA/RNA extraction wizards
					</dt>
					<dd>
						<ul>
						<li><a href="allprep_protocol.jsp?ID=<%=ID%>">Lab tracking protocol for Allprep isolation</a>
						<li><a href="extraction_registration.jsp?ID=<%=ID%>">DNA/RNA/FlowThrough registration</a>
						</ul>
					</dd>
					<dt>
						<base:icon image="<%=home+"/images/rnaqc.png" %>" />
						RNA quality control wizards
					</dt>
					<dd>
						<ul>
						<li><a href="rnaqc_aliquot.jsp?ID=<%=ID%>">Create aliquots on Bioanalyzer/Caliper plates</a>
						<li><a href="rnaqc_plate_export.jsp?ID=<%=ID%>">Export Caliper sample names and run parameters</a>
						<li><a href="rnaqc_plate_import.jsp?ID=<%=ID%>">Import RQS scores from Caliper well table file</a>
						</ul>
					</dd>
					<%
				}
				%>				
				</dl>
			</div>
		</div>
		
		<div class="absolutefull" style="width: 50%; left: auto;">
			<div class="absolutefull" style="left: 0.5em; right: 1em;">
				<h3>Reggie reports</h3>
				<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home+"/images/report.png" %>" />
						<a href="samplereportgenerator.jsp?ID=<%=ID%>">Report generator</a>
					</dt>				
					<dd>				
						<ul>
						<li>Sample count report</li> 
						</ul>
					</dd>
				</dl>
			
			</div>
		</div>

	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>